所有内容都在`src`目录下

项目的**接口**在`api`目录下统一管理，用的时候引入该目录下对应的接口文本即可

```js
import commonAPI from '@/api/common'

commonAPI.xxx({data}).then(res => console.log(res))
```

`assets`目录存放图片、iconfont等资源文件

`common`目录存放所有公共的方法，比如我们用axios封装的request.js和工具类util.js

`components`目录存放项目的组件，建议只存放无关业务的组件，或是从业务中抽离的公共组件

`config`目录存放各类配置文件

`filters`目录存放自定义的过滤器，过滤器已经在`main.js`中全局引入，一般情况下只需要在`filters/index.js`中新增过滤器即可

`layouts`目录存放页面的最外层布局组件，是从views中单独抽离出来的，方便直接改变、管理最外层布局

`locale`目录存放多语言文件，使用规则如下：

> 配置对应语言的文件夹，然后在messages.js中引入并导出即可。

`router`目录存放并控制项目的所有路由

`store`目录是`VUEX`的存放目录，负责统一管理VUEX

`style`目录存放所有的样式文件，目前`mixin.scss`和`_var.scss`是全局引入的，如果需要全局引入更多的样式文件，可以在`vue.config.js`中的`css->loaderOptions->sass`下依法添加

`views`目录存放所有的页面组件，可以依据项目自己划分层级